/**
 * @file  Fehler.h
 * @brief Definition der Klasse Fehler.
 */

#ifndef __FEHLER_
#define __FEHLER_

#include <string>
using namespace std;

/*!
 * @class Fehler
 * @brief Eine Fehlerklasse.
 */
class Fehler
{
private:
    string fehlerMeldung_;				//!< Die Fehlermeldung in ausformulierter Textform.
    int fehlerNummer_;					//!< Die Fehlermeldung als Zahlencode.
    
public:
    Fehler();
    Fehler( string fehlerMeldung, int fehlerNummer = 0 );
       
    void ergaenzeMeldung( string ergaenzung );
    string gibMeldung();
    int gibFehlerNummer();

	Fehler &operator= ( Fehler &copyFehler );
	friend ostream &operator<< ( ostream &os, Fehler fehler );

private:
    void log();
};

#endif
