/*!
 * @file  Koordinaten.cpp
 * @brief Implementierung der Klasse Koordinaten.
 */

#include "Koordinaten.h"


/*!
 * @fn		Koordinaten::Koordinaten( )
 * @brief	Default-Konstruktor der Klasse Koordinaten
 *
 * @author	Nico Schroeder
 */
Koordinaten::Koordinaten(){
	x = 0;
	y = 0;
	z = 0;
}

/*!
 * @fn		Koordinaten::Koordinaten( double tmpX, double tmpY, double tmpZ )
 * @brief	Default-Konstruktor der Klasse Koordinaten
 *
 * @author	Nico Schroeder
 * @param	tmpX der x-Wert
 * @param	tmpY der y-Wert
 * @param	tmpZ der z-Wert
 */
Koordinaten::Koordinaten( double tmpX, double tmpY, double tmpZ ){
	x = tmpX;
	y = tmpY;
	z = tmpZ;
}

/*!
 * @fn		ostream &operator<< ( ostream &os, Koordinaten koordinaten )
 * @brief	Ueberladener Operator "<<" z.B. zur Ausgabe von Koordinaten ueber cout
 *
 * @author	Nico Schroeder
 *
 * @param	os Der zu modifizierende OutStream
 * @param	koordinaten Die auszugebenden Koordinaten
 * @return	Der modifizierte OutStream
 */
ostream &operator<< ( ostream &os, Koordinaten koordinaten ){
	os << "(" << koordinaten.x << ", " << koordinaten.y << ", " << koordinaten.z << ")";
	return os;
}