/*!
 * @file  ListenDaten.cpp
 * @brief Implementierung der Klasse ListenDaten.
 */

#include "ListenDaten.h"

/*!
 * @fn		bool ListenDaten::sollEntferntWerden()
 * @brief	Ermittelt, ob ein Objekt aus einer Liste genommen werden soll.
 *
 * @author	Nico Schroeder
 *
 * @return	TRUE, wenn ein Objekt enfernt werden soll, sonst FALSE
 */
bool ListenDaten::sollEntferntWerden(){
	return loescheMich_;
}

/*!
 * @fn		long int ListenDaten::gibId()
 * @brief	Liefert die ID des aktuellen Objektes
 *
 * @author	Nico Schroeder
 *
 * @return die ID des Objektes
 */
long int ListenDaten::gibId(){
	return id_;
}

/*!
 * @fn		ListenDaten::setzeId( long int id )
 * @brief	Setzt die ID des aktuellen Objektes
 *
 * @author	Nico Schroeder
 *
 * @param	id Die zu setztende Id
 */
void ListenDaten::setzeId( long int id ){
	id_ = id;
}

/*!
 * @fn		ostream &operator<< ( ostream &os, ListenDaten *listenDaten )
 * @brief	Ueberladener Operator "<<" z.B. zur Ausgabe eines Fahrzeuges ueber cout
 *
 * @author	Nico Schroeder
 */
ostream &operator<< ( ostream &os, ListenDaten *listenDaten ){
	listenDaten->inString();
	return os;
}