/*!
 * @file  ListenDaten.h
 * @brief Definition der Klasse ListenDaten.
 */

#ifndef __LISTENDATEN_
#define __LISTENDATEN_

#include <iostream>
using namespace std;


/*!
 * @class ListenDaten
 * @brief Eine abstrakte Klasse fuer die Objekte der Listen
 */
class ListenDaten
{
	public:
		virtual void takt( double zeitintervall ) = 0;
		virtual void inString( ) = 0;
		bool sollEntferntWerden();
		long int gibId();
		void setzeId( long int id );
		virtual void aufraeumen() = 0;
		virtual void exportieren( string cvsDateiname ) = 0;
		friend ostream &operator<< ( ostream &os, ListenDaten *listenDaten );
	protected:
		long int id_;						//!< eindeutige ID zum Wiederfinden der Objekte
		long int idBenutzer_;				//!< eindeutige ID zum Wiederfinden der Objekte (vom Benutzer vergeben)
		bool loescheMich_;					//!< Flag, welches anzeigt, dass ein Objekt aus der Liste geloescht werden will
};

#endif