/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qstring.h>
#include <qfiledialog.h>
#include <qfileinfo.h>
#include <qmessagebox.h>
#include <qpushbutton.h>
#include <qframe.h>

#include "../Fehler.h"

//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::init()
{
    timer_ = new QTimer();
    stopFlag_ = 0;
    xmlDateiGeladen_ = 0;
    openGL_ = 0;
    zeit_ = 0;
    maus_ = 2;
    
    // Timer mit Antakt-Funktion verbinden
    connect( timer_, SIGNAL( timeout() ), SLOT( simulationAntakten() ) );
    
    // Das Menue erstellen
    popupSimulation_ = new QPopupMenu;
    popupKontrolle_ = new QPopupMenu;
    popupHilfe_ = new QPopupMenu;
    
    popupSimulation_->insertItem( "&ffnen...", this, SLOT( importieren() ),  CTRL+Key_O );
#ifndef _WIN32 && #ifndef WIN32 && #ifndef __WIN32__
    // MAC OS ist gefragt
    popupSimulation_->insertSeparator();
#endif
    popupSimulation_->insertItem( "&Exportieren...", this, SLOT( exportieren() ),  CTRL+Key_E,1 );
    popupSimulation_->insertSeparator();
	
	// MAC OS hat Beenden-Eintrag im Programm-Menue
#ifndef _WIN32 && #ifndef WIN32 && #ifndef __WIN32__
    // MAC OS ist gefragt
    popupSimulation_->insertItem( "quit", this, SLOT( close() ),  CTRL+Key_Q );
#else
    // Windows ist gefragt
    popupSimulation_->insertItem( "&Beenden", this, SLOT( close() ),  CTRL+Key_Q );
#endif
       
    popupKontrolle_->insertItem( "&Ansicht zurcksetzen", this, SLOT( ansichtRuecksetzen() ), CTRL+Key_R,2 );
    popupKontrolle_->insertSeparator();
    popupKontrolle_->insertItem( "&Scrollrad-Maussteuerung", this, SLOT( scrollMaus() ), CTRL+Key_1,4 );
    popupKontrolle_->insertItem( "&2-Tasten-Maussteuerung", this, SLOT( tastenMaus() ), CTRL+Key_2,3 );
    
	// MAC OS hat About-Eintrag im Programm-Menue
#ifndef _WIN32 && #ifndef WIN32 && #ifndef __WIN32__
    // MAC OS ist gefragt
    popupHilfe_->insertItem("About", this, SLOT( about() ) );
#else
    // Windows ist gefragt
    popupHilfe_->insertItem("&ber TraffSpot...", this, SLOT( about() ) );
#endif
    
    popupSimulation_->setItemEnabled( 1, false );
    popupKontrolle_->setItemEnabled( 2, false );
    popupKontrolle_->setItemEnabled( 3, false );
    popupKontrolle_->setItemEnabled( 4, false );
    
    menu_ = new QMenuBar( this );
    menu_->insertItem( "&Simulation", popupSimulation_ );
    menu_->insertItem( "&Kontrolle", popupKontrolle_ );
    menu_->insertItem( "&Hilfe", popupHilfe_ );
}
//------------------------------------------------------------------------------------------------------------------


//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::simulationStarten()
{
    if( stopFlag_== TRUE ){
		traffspot_.initialisieren( xmlPfad_.latin1() );
		openGL_->setzeFahrzeugliste( traffspot_.gibFahrzeugliste() );
		openGL_->setzeSpurenliste( traffspot_.gibSpurenliste(), traffspot_.gibAnzahlSpuren() );
		openGL_->setzeKreuzungsliste( traffspot_.gibKreuzungsliste() );
		zeit_ = 0;
    }

    timer_->start( spinBoxEntscheidungszeit->value() / spinBoxSimulationszeit->value(), FALSE );
 
    toolButtonPlay->setEnabled( FALSE );
    toolButtonPause->setEnabled( TRUE );
    toolButtonStop->setEnabled( TRUE );
    
    // Export ermoeglichen
    pushButtonExport->setEnabled( TRUE );
    popupSimulation_->setItemEnabled( 1, true );
}
//------------------------------------------------------------------------------------------------------------------

void Hauptfenster::zeitAnpassen()
{
    if( timer_->isActive() )
 timer_->changeInterval( spinBoxEntscheidungszeit->value() / spinBoxSimulationszeit->value() );
}

//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::simulationPausieren()
{
    timer_->stop();
    stopFlag_= FALSE;
 
    toolButtonPlay->setEnabled( TRUE );
    toolButtonPause->setEnabled( FALSE );
    toolButtonStop->setEnabled( FALSE );
}
//------------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::simulationStoppen()
{
    timer_->stop();
    stopFlag_= TRUE;
 
    toolButtonPlay->setEnabled( TRUE );
    toolButtonPause->setEnabled( FALSE );
    toolButtonStop->setEnabled( FALSE );
}
//------------------------------------------------------------------------------------------------------------------



//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::simulationAntakten()
{
    int minuten(0), sekunden(0), msekunden(0);
 
    try
    {   // Taktzeit holen
		traffspot_.setzeTaktzeit( (double) spinBoxEntscheidungszeit->value()/1000 );
		// Simulation antakten
		traffspot_.takt();
		openGL_->zeichne();
		zeit_ += (double) spinBoxEntscheidungszeit->value() / 1000;
		minuten = zeit_ / 60;
		sekunden =  zeit_ - (minuten * 60);
		msekunden = (zeit_ - sekunden - minuten * 60) * 10;
		if( sekunden < 10 && minuten < 10 )
			textLabelVergangeneZeit->setText( QString("0%1:0%2,%3min" ).arg(minuten).arg(sekunden).arg(msekunden));
		else if( sekunden < 10 )
			textLabelVergangeneZeit->setText( QString("%1:0%2,%3min" ).arg(minuten).arg(sekunden).arg(msekunden));
		else if( minuten < 10 )
			textLabelVergangeneZeit->setText( QString("0%1:%2,%3min" ).arg(minuten).arg(sekunden).arg(msekunden));
		else
			textLabelVergangeneZeit->setText( QString("%1:%2,%3min" ).arg(minuten).arg(sekunden).arg(msekunden));
    }
    catch( Fehler *fehler)
    {   // Simulation beenden
		simulationStoppen();
		fehlerAnzeigen( fehler );
    }  
}
//------------------------------------------------------------------------------------------------------------------



//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::exportieren()
{
    int ok(0);
    QFileInfo *aktuelleDatei;
    QString dateinameFahrzeuge, dateinameKreuzungen;
 
    Hinweisfenster *hinweis = new Hinweisfenster( this, "Exportieren" ,  true );
    hinweis->setzeMeldung( "Whlen Sie den Ort, an dem die Fahrzeugstatistiken abgespeichert werden sollen..." );
    hinweis->setzeUeberschrift( "<b>Exportieren:</b>" );
    hinweis->show();
    hinweis->exec();
    delete hinweis;
    
    while( ok == 0 )
    {
 dateinameFahrzeuge = QFileDialog::getSaveFileName( QString::null, "TEXT CSV (*.csv)", this );
 if( dateinameFahrzeuge == QString::null )
     return;
    
 // Falls die Endung .csv nicht anhaengt, diese automatisch anhaengen
 if ( dateinameFahrzeuge.find ( ".csv" ) == -1 )
     dateinameFahrzeuge += ".csv";
    
 // Schaue, ob die Datei exisitiert .. wenn ja frage nach ob sie ueberschrieben werden soll
 aktuelleDatei = new QFileInfo( dateinameFahrzeuge );
 if( aktuelleDatei->exists() )
 {
     // Abfrage ob die Datei ueberschrieben werden soll
     QMessageBox frage( "Datei existiert", QString("Sollen an die bestehende Datei %1 \ndie aktuellen Fahrzeugstatistiken angehangen werden ?").arg(dateinameFahrzeuge), QMessageBox::Warning, QMessageBox::Yes | QMessageBox::Default, QMessageBox::No, QMessageBox::Cancel | QMessageBox::Escape );
     frage.setButtonText( QMessageBox::Yes,    "Ja");
     frage.setButtonText( QMessageBox::No,      "Nein");
     frage.setButtonText( QMessageBox::Cancel,      "Abbrechen");
       
     // Auswertung der Entscheidung des Nutzers
     switch ( frage.exec() )
     {
     case QMessageBox::Yes:
  ok = 1;
  break;
     case QMessageBox::No:
  ok = 0;
  break;
     case QMessageBox::Cancel:
  return;
  break;
     }
 }
 else
 {
     ok = 1;
 }
    }
    
    ok = 0;

    hinweis = new Hinweisfenster( this, "Exportieren" ,  true );
    hinweis->setzeMeldung( "Whlen Sie nun den Ort fr die Kreuzungsstatistik..." );
    hinweis->setzeUeberschrift( "<b>Exportieren:</b>" );
    hinweis->show();
    hinweis->exec();
    delete hinweis;

    while( ok == 0 )
    {
 dateinameKreuzungen = QFileDialog::getSaveFileName( QString::null, "TEXT CSV (*.csv)", this );
 if( dateinameKreuzungen == QString::null )
     return;
     
 // Falls die Endung .csv nicht anhaengt, diese automatisch anhaengen
 if ( dateinameKreuzungen.find ( ".csv" ) == -1 )
     dateinameKreuzungen += ".csv";
    
 // Schaue, ob die Datei exisitiert .. wenn ja frage nach ob sie ueberschrieben werden soll
 aktuelleDatei = new QFileInfo( dateinameKreuzungen );
 if( aktuelleDatei->exists() )
 {
     // Abfrage ob die Datei ueberschrieben werden soll
     QMessageBox frage( "Datei existiert", QString("Sollen an die bestehende Datei %1 \ndie aktuellen Kreuzungsstatistiken angehangen werden ?").arg(dateinameKreuzungen), QMessageBox::Warning, QMessageBox::Yes | QMessageBox::Default, QMessageBox::No, QMessageBox::Cancel | QMessageBox::Escape );
     frage.setButtonText( QMessageBox::Yes,    "Ja");
     frage.setButtonText( QMessageBox::No,      "Nein");
     frage.setButtonText( QMessageBox::Cancel,      "Abbrechen");
       
     // Auswertung der Entscheidung des Nutzers
     switch ( frage.exec() )
     {
     case QMessageBox::Yes:
  ok = 1;
  break;
     case QMessageBox::No:
  ok = 0;
  break;
     case QMessageBox::Cancel:
  return;
  break;
     }
 }
 else
 {
     ok = 1;
 }
    }
    
     
     
    try
    {
        traffspot_.exportieren( dateinameFahrzeuge.latin1(), dateinameKreuzungen.latin1() );
    }
    catch( Fehler *fehler)
    {
        fehlerAnzeigen( fehler );
    }
 
    hinweis = new Hinweisfenster( this, "Exportieren:" ,  true );
    hinweis->setzeMeldung( "Die Statistiken wurden erfolgreich abgespeichert." );
    hinweis->setzeUeberschrift( "<b>Exportieren:</b>" );
    hinweis->show();
    hinweis->exec();
    delete hinweis;
}
//------------------------------------------------------------------------------------------------------------------



//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::importieren()
{
    if( !toolButtonPlay->isEnabled() ){
		simulationStoppen();
    }
    
    // Simulation nicht abspielbar machen
    if( xmlDateiGeladen_ == 0 ){
		toolButtonPlay->setEnabled( FALSE );
		popupKontrolle_->setItemEnabled( 2, FALSE);
		popupKontrolle_->setItemEnabled( 3, FALSE);
		popupKontrolle_->setItemEnabled( 4, FALSE);
		popupSimulation_->setItemEnabled( 1, FALSE);
		pushButtonExport->setEnabled( FALSE );
    }
    
 
    // XML-Datei finden
    QString dateiname = QFileDialog::getOpenFileName( QString::null, "*.xml", this );
       
    if( dateiname.isEmpty() )
    {
		return;
    }
    
    
    
    // Simulation initialisieren
    try
    {
		xmlPfad_ = dateiname;
		traffspot_.initialisieren( xmlPfad_.latin1() );
   
		// GL-Fenster in vorgesehenden Rahmen stecken
		if( openGL_ != 0 ){
			delete openGL_;
			openGL_ = 0;
		}
		openGL_ = new GLWireframe( groupBoxSimulation, "glbox", 0, 0, traffspot_.gibSpurenliste(), traffspot_.gibAnzahlSpuren(),traffspot_.gibKreuzungsliste() );
		openGL_->setzeFahrzeugliste( traffspot_.gibFahrzeugliste() );
		openGL_->setGeometry(10, 20, groupBoxSimulation->width()-23,groupBoxSimulation->height()-30);
		openGL_->show();
		ansichtRuecksetzen();
		zeit_ = 0;
		textLabelVergangeneZeit->setText( QString("00:00,0min" ));
		xmlDateiGeladen_ = 1;
    }
    catch( Fehler *fehler)
    {
		fehlerAnzeigen( fehler );
		return;
    }
    
    // Maussteuerung einstellen
    if( maus_ == 1 )
		tastenMaus();
    else
		scrollMaus();
    
    // Simulation abspielbar machen
    toolButtonPlay->setEnabled( TRUE );
    popupKontrolle_->setItemEnabled( 2, TRUE);
    popupSimulation_->setItemEnabled( 1, TRUE);
    pushButtonExport->setEnabled( TRUE );
}
//------------------------------------------------------------------------------------------------------------------



//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::fehlerAnzeigen(Fehler *fehler)
{
    QString fehlernachricht = QString( "%1").arg( fehler->gibMeldung().c_str() );
    Hinweisfenster *hinweis = new Hinweisfenster( this, "Fehler" ,  true );
    hinweis->kritisch();
    hinweis->setzeMeldung( fehlernachricht );

    hinweis->show();
    hinweis->exec();
    
    delete hinweis;
}
//------------------------------------------------------------------------------------------------------------------



//------------------------------------------------------------------------------------------------------------------
void Hauptfenster::about()
{
    Aboutfenster *about = new Aboutfenster( this, "about" ,  true );

    about->show();
    about->exec();
    
    delete about;
}
//------------------------------------------------------------------------------------------------------------------

void Hauptfenster::ansichtRuecksetzen()
{
    if( openGL_ != 0 )
 openGL_->ladeWerkseinstellungen();
}


void Hauptfenster::resizeEvent( QResizeEvent * aenderung )
{
    // Aenderung errechnen    
    int breite = aenderung->size().width()-22;
    int hoehe = aenderung->size().height()-95;

    if( breite < 650 )
		breite = 650;
    
    // MAC OS hat seine Menueleiste nicht im Fenster .. also alles nach oben schieben
#ifndef _WIN32 && #ifndef WIN32 && #ifndef __WIN32__
    // MAC OS ist gefragt
    line->setGeometry(0,62,breite+22,16);
    groupBoxSimulation->setGeometry( 10, 70, breite+3, hoehe-3);
    pixmapLabelTruck->setGeometry(breite-55,2,80,60);
#else
    // Windows ist gefragt
    line->setGeometry(0,84,breite+22,16);
    
    groupBoxKontrolle->setGeometry(10,25,150,60);
    groupBoxReaktionszeit->setGeometry(171,25,100,60);
    groupBoxSimulationszeit->setGeometry(286,25,150,60);
    groupBoxWerkzeuge->setGeometry(440,25,90,60);
    
    groupBoxSimulation->setGeometry( 10, 93, breite, hoehe-20);
    pixmapLabelTruck->setGeometry(breite-55,27,80,60);
#endif

 if( openGL_ != 0 )
  openGL_->setGeometry(10, 20, groupBoxSimulation->width()-23,groupBoxSimulation->height()-30);
}

void Hauptfenster::tastenMaus()
{
    if( openGL_ != 0 )
    {
		openGL_->setzeMaussteuerung( 1 );
		popupKontrolle_->setItemEnabled( 3, false );
		popupKontrolle_->setItemEnabled( 4, true ); 
		maus_ = 1;
	}    
}

void Hauptfenster::scrollMaus()
{
    if( openGL_ != 0 )
    { 
		openGL_->setzeMaussteuerung( 2 );
		popupKontrolle_->setItemEnabled( 3, true );
		popupKontrolle_->setItemEnabled( 4, false ); 
		maus_ = 2;
	}    
}
