/*!
 * @file  SzenarioParser.h
 * @brief Definition des Parsers um Szenarien aus einer XML-Datei auslesen zu koennen.
 */

#ifndef SZENARIO_PARSER_H
#define SZENARIO_PARSER_H   

#include "../Liste.h"
#include "../Spur.h"

/*!
 * @class SzenarioParser
 * @brief Parst eine als XML hinterlegte Strassenkarte und schreibt entsprechende Daten in Listen und Arrays.
 */
class SzenarioParser
{
public:
		SzenarioParser( char *file, Spur ***spurenArray, Liste *generatorListe, Liste *kreuzungsListe, Liste *fahrzeugeListe );
	int parseXml();

	Liste *generatorListe_;		//!< Zeiger auf die Liste der Fahrzeuggeneratoren
	Liste *kreuzungsListe_;		//!< Zeiger auf die Liste der Kreuzungen
	Liste *fahrzeugeListe_;		//!< Zeiger auf die Liste der Fahrzeuge
	Spur ***spurenArrayTmp_;	//!< Zeiger auf den Zeiger auf das erste Element des Spuren
	Spur **spurenArray_;		//!< Zeiger auf das erste Element des Spuren

private:
		SzenarioParser();

	int		 countXml();
	long int getXml();
	
	char *file_;				//!< Dateipfad zur XML-Datei
};	

#endif